
;**********************************************************************

	list      p=12F683        ; list directive to define processor
	#include <P12F683.inc>    ; processor specific variable definitions

	errorlevel  -302          ; suppress message 302 from list file

	__CONFIG   _FCMEN_ON & _IESO_OFF & _CP_OFF & _CPD_OFF & _BOD_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_OFF & _INTRC_OSC_NOCLKOUT 

;² , Ͳ   Ҳ ̲ в,    .ASM
	#include <KOROTKO.INC>    ;

;***** VARIABLE DEFINITIONS
w_temp        EQU     0x70        ; variable used for context saving 
status_temp   EQU     0x71        ; variable used for context saving
W	equ 0
F	equ 1
;;;;;;;;;;;
      cblock  20H
	PauzaHV					;      =300  -21 
	VysotaZvuku				;     
	HV						;      300  -21
	LICH                       ;  
	FLAG        
	                             ; 0-
	                             ; 1-    
	                             ; 2-    
	                             ; 3-    
                                 ;      
 
	TimeVym                    ; -    (300 )  
                               ;   1,   6
	LimVym            ;=50=300(5)/6( 1 -  
	LIM1               ;     
	LIM2               ;     

	ZATR1			;     0,25
	ZATR2			; ( Zatr250msec -  0,25)
	ZATR3			;   
	ZATR4			;   ""
	ZATR5			;   ""

	endc

; initialize eeprom locations

	ORG	0x2100		;  EEPROM
	DE	0x32, 0x61, 0x28, 0x63	;     EEPROM 
; 0X32 = 50 = 300(5)/6( 1 -     -21   1
; 0X61  = 97 =   ,      
				;   300  -21 (    )
; 0X28 = 40 =   40/ -         -21
; 0X63 = 99 =   100/ -   "" (,    )
;
;**********************************************************************
	ORG     0x000             ; processor reset vector
	goto    main              ; go to beginning of program
	


;***********************************
Podija	ORG     0x004             ;  Ѳ 
	BTFSC	INTCON,GIE
	GOTO	Podija		;    ( ,   )
;-------------------------------
; W,STATUS
;------------------------------- 

	movwf   w_temp            ; save off current W register contents
	movf	STATUS,w          ; move status register into W register
	movwf	status_temp       ; save off contents of STATUS register

	
; isr code can go here or be located as a call subroutine elsewhere
	BTFSC	INTCON,INTF	;    GPIO2(INT) (  )
	GOTO	IMP_Geigera	;     


	BTFSC PIR1,TMR1IF   ;   1
	GOTO Chas_Vym	

	GOTO Podija_End


IMP_Geigera                     ;       
	BCF	INTCON,INTF				; clear the GPIO2(INT) flag
	CALL IMPULS
	GOTO Podija_End
Chas_Vym                   		;    1
	BCF PIR1,TMR1IF        ;
	CALL TIMER1          ;
	GOTO Podija_End

Podija_End
	movf    status_temp,w     ; retrieve copy of STATUS register
	movwf	STATUS            ; restore pre-isr STATUS register contents
	swapf   w_temp,f
	swapf   w_temp,w          ; restore pre-isr W register contents

	retfie                    ; return from interrupt
;****************************************************************************************
main
	bsf	       STATUS, RP0	 ;   1
	clrf      ANSEL
	CLRF TRISIO
	MOVLW        b'00010100'; GP2,GP4   (GP2(INT) - .,GP4 - .""
	MOVWF      TRISIO

 	MOVLW     b'00000000'  ;1-    , 0 -  (7-	, 
	MOVWF OPTION_REG       ;  )

	MOVLW     b'00010000'  ;    GP4
	MOVWF WPU       ;
;	MOVLW        b'00000010'  ;    31
							;b'_XXX_ _ _ _' 000 - 31,  001 - 125, 010 - 250
							;               011 - 500, 100 - 1,   101 - 2, 
							;               110 - 4,   111 - 8.
;	MOVLW        b'01000010'  ;    1/   1:1  1 = 262.
;	MOVLW        b'01010010'  ;    2/   1:8  1 = 1,048576 .
;	MOVLW        b'01100010'  ;    4
;	MOVLW		b'00110010'  ;    500///////////////////////////
	MOVLW		b'00100010'  ;    250///////////////////////////
;	MOVLW		b'00010010'  ;    125///////////////////////////
;;	MOVLW        b'01110010'  ;    8///////////////////////////
	movwf	OSCCON

;;	MOVLW        b'11001000'   ;11001000 - , (1),GPIO change (GP3   IOC)
	MOVLW        b'01010000'   ;01001000 -  1(6),GP2(INT)(4) change 
	MOVWF	INTCON
;	MOVLW        b'00001000'
;	movwf	IOC                     ;     GP3(pin4)-.
	CLRF	IOC	

	MOVLW  b'00000001'   ;    1
	movwf PIE1

	bCf	       STATUS, RP0   ;   0
 	movlw  07h         ;  
	movwf   CMCON0      ;   

	MOVLW   b'00110001'  ; 1 + 11=1:8, 1 
;	MOVLW   b'00000001'  ; 1 + 00=1:1, 1 
;	MOVLW   b'00010001'  ; 1 + 01=1:2, 1 

	movwf   T1CON       ;       Fosc/4

	BCF		GPIO,0		;       -21
	BCF		GPIO,5		;     

	CLRW        ;   0-  EEPROM
	CALL READ_MEM   ; =50=300(5)/6( 1) -  
	MOVWF LimVym    ;


	movlw .1        ;   1-  EEPROM
	CALL READ_MEM   ; 
	MOVWF HV		; = 97 =   ,      
					;   300  -21 (    )

	movlw .2        ;   2-  EEPROM
	CALL READ_MEM   ; = 40 =   40/ -         -21
	MOVWF LIM1    ; 

	movlw .3        ;   3-  EEPROM
	CALL READ_MEM   ; = 99 =   100/ -   "" (,    )
	MOVWF LIM2    ; 

	CLRF LICH
	clrf FLAG
	CLRF TimeVym


	CALL	PYSHCHYK			;     
	BSF		GPIO,5				;  
	CALL 	Zatr250msec           ;  0,25
	CALL 	Zatr250msec           ;  0,25
	BCF		GPIO,5				;  

;;; в  1  Ĳ  8,388608  6 
;   1   0x48  0xE5 ,
;  18661
; 8,388608 / 65536 (.   16- ) = 128
;(8,388608 - 6.)/0,000128 = 18661 = 0X48,0xE5
	LOADF	TMR1H,0x48
	LOADF	TMR1L,0xE5	

	BSF		INTCON,GIE

CYCLE                      ;     *****************
;     -21
	BSF      GPIO,0         ;       -21
	NOP
	BCF      GPIO,0         ; 
; ======    250 =========
;  ,     300   -21
; HV=57 -  300( ),  2,824,  32 
; HV=77 -  260( ),  3,784,  32
; HV=97 -  240( ),  4,744,  32
;      ,   
	MOVF_F	HV,PauzaHV
	DECFSZ	PauzaHV,F
	GOTO	$-1	  

     goto      CYCLE         ;     ****************

;;;;;;;;;;;;;ϲ;;;;;;;;;;;;;;;;;

;-------------------------------------------------------------------------------
IMPULS			;        -21
	INCF     LICH,F   ;      
	MOVF     LICH,0   ;    ""
	
	btfsc FLAG,1      ;
	GOTO porig2

	SUBWF    LIM1,0       ;       LIM1 
	BTFSS STATUS,C      ;      '  
	goto PEREVYSHCH1   ;     
	GOTO kin
porig2
	MOVF     LICH,0   ;    ""
	SUBWF    LIM2,0     ;      LIM2 
	BTFSS STATUS,C      ;     ""
	goto PEREVYSHCH2   ;     
kin
	btfsc FLAG,1      ;       1-     
	GOTO pic     ;              -21

	BTFSC FLAG,3      ;        1- 
	GOTO pic      ;              -21

	BTFSS	GPIO,4	;    ,    
	GOTO pic		;        -21

	GOTO KinIMPULS
pic
	call PYSHCHYK 

KinIMPULS

	RETURN
;---------------------------------------------------------------------------------------
PEREVYSHCH1			;        (40/)
	call PYSHCHYK
	BSF FLAG,1    ;     
	BSF FLAG,3   ;     
                  ;     
                  ;    
	RETURN
;---------------------------------------------------------------------------------------
PEREVYSHCH2			;        (100/)
	BSF FLAG,2    ;     
	call TRYVOGA
	CALL Zatr250msec           ;  0,25
	call TRYVOGA
	CALL Zatr250msec           ;  0,25
	call TRYVOGA
;;; в  1  Ĳ  8,388608  6 
;   1   0x48  0xE5 ,
;  18661
; 8,388608 / 65536 (.   16- ) = 128
;(8,388608 - 6.)/0,000128 = 18661 = 0X48,0xE5
	LOADF	TMR1H,0x48
	LOADF	TMR1L,0xE5	
	CLRF LICH
	RETURN
;----------------------------------------------------------------------------------------
TRYVOGA         ;  
	BSF		GPIO,5					;  
	CLRF	VysotaZvuku						;     
	BSF   VysotaZvuku,0						;     
	LOADF	ZATR5,D'5'
Znovu
	INCF   VysotaZvuku,F						;     
	CALL Zatr250msec           ;  0,25
	LOADF	ZATR4,D'13'
zvk
	CALL PYSHCHYK
	decfsz      ZATR4,F
     goto        zvk
	decfsz      ZATR5,F
     goto        Znovu
	BCF		GPIO,5				;  
 ; 5-  
	LOADF	ZATR4,D'26'
DovgZvuk
	CALL PYSHCHYK
	decfsz      ZATR4,F
     goto        DovgZvuk
BezZvuku
	RETURN
;---------------------------------------------------------------------------------------
KINVYM                           
	CLRF TimeVym     ; -  1
	CLRF LICH        ; - 

	BTFSS FLAG,1     ;         
	BCF	  FLAG,3     ;   3 = 1
	BCF   FLAG,1     ;    1, 
                      ;      
                      ;   1-         
	RETURN
;------------------------------------------------------------------------------------------
TIMER1     ;      1
           ; ,   Ͳ 6.
           ;     = LimVym(=50=300/6) x 6 
           ;    =KINVYM= 
	INCF     TimeVym,f   ;        
	MOVF     TimeVym,w   ;    ""
	SUBWF    LimVym,w       ;       LimVym 
	BTFSS   STATUS,C      ;     
	CALL    KINVYM             ; - LICH
;;; в  1  Ĳ  8,388608  6 
;   1   0x48  0xE5 ,
;  18661
; 8,388608 / 65536 (.   16- ) = 128
;(8,388608 - 6.)/0,000128 = 18661 = 0X48,0xE5
	LOADF	TMR1H,0x48
	LOADF	TMR1L,0xE5	
	RETURN
;--------------------------------------------------------------------------------
PYSHCHYK
	LOADF	ZATR3,D'77'	
zvtrv3
	BSF GPIO,1
	NOP
	BTFSS VysotaZvuku,0						;     
	GOTO	KinecxImpulsa1	
	NOP
	NOP
KinecxImpulsa1
	BCF GPIO,1
	NOP
	BTFSS VysotaZvuku,0						;     
	GOTO	KinecxImpulsa0
	NOP
	NOP
KinecxImpulsa0
	DECFSZ      ZATR3,F
    GOTO       zvtrv3
	RETURN
;-------------------------------------------------------------------------------
Zatr250msec           ;  0,25
	CLRF	ZATR1
	LOADF	ZATR2,D'21'
           decfsz      ZATR1,F
            goto        $-1
            decfsz      ZATR2,F
            goto        $-3
	RETURN
;---------------------------------------------------------------------------------------------------
READ_MEM
       bsf        STATUS, RP0          ;   1
       movwf   EEADR 
       bsf        EECON1, RD            ; 
       movfw     EEDATA                ;     W
       bcf        STATUS, RP0          ;   0 
       return
;------------------------------------------------------------------------------




	END                       ; directive 'end of program'

